/******************************************************************************/
/* Copyright 2008-2009 CNRS, INRIA                                            */
/*                                                                            */
/* File          : hips_fortran.h                                             */
/*                                                                            */
/* Description   : This file is part of HIPS : Hierarchical Iterative         */
/*                 Parallel Solver (http://hips.gforge.inria.fr/).            */
/*                                                                            */
/* Authors       : J. GAIDAMOUR and P. HENON                                  */
/******************************************************************************/

/******************************************************************************/
/* License       : CeCILL-C                                                   */
/*                                                                            */
/* This software is governed by the CeCILL-C license under French law and     */
/* abiding by the rules of distribution of free software. You can use,        */
/* modify and/or redistribute the software under the terms of the             */
/* CeCILL-C license as circulated by CEA, CNRS and INRIA at the following     */
/* URL: "http://www.cecill.info".                                             */
/*                                                                            */
/* As a counterpart to the access to the source code and rights to copy,      */
/* modify and redistribute granted by the license, users are provided         */
/* only with a limited warranty and the software's author, the holder of      */
/* the economic rights, and the successive licensors have only limited        */
/* liability.                                                                 */
/*                                                                            */
/* In this respect, the user's attention is drawn to the risks associated     */
/* with loading, using, modifying and/or developing or reproducing the        */
/* software by the user in light of its specific status of free software,     */
/* that may mean that it is complicated to manipulate, and that also          */
/* therefore means that it is reserved for developers and experienced         */
/* professionals having in-depth computer knowledge. Users are therefore      */
/* encouraged to load and test the software's suitability as regards          */
/* their requirements in conditions enabling the security of their            */
/* systems and/or data to be ensured and, more generally, to use and          */
/* operate it in the same conditions as regards security.                     */
/*                                                                            */
/* The fact that you are presently reading this means that you have had       */
/* knowledge of the CeCILL-C license and that you accept its terms.           */
/******************************************************************************/


#ifndef HIPS_FORTRAN_H

#define HIPS_FORTRAN_H

#define DISABLE_C
#include "hips.h"

/*#if defined(SP2) || defined(RS6000) || defined(AIX) 
#define FORTRAN_NAME(name) name  
#else
#define FORTRAN_NAME(name) name ## _

#endif*/


/** Macro from Scotch **/

#define FORTRAN_NAME(nu,nl,pl,pc)                     \
void nu pl;                                      \
void nl pl                                       \
{ nu pc; }                                       \
void nl##_ pl                                    \
{ nu pc; }                                       \
void nl##__ pl                                   \
{ nu pc; }                                       \
void nu pl


/** NE PAS METTRE
void FORTRAN_NAME(HIPS_INITIALIZE)(INTS *nid);
void FORTRAN_NAME(HIPS_SET_DEFAULT_OPTIONS)(INTS *id, INTS *stratnum);
void FORTRAN_NAME(HIPS_SET_OPTION_INT)(INTS *id, INTS *number, INTS *value);
void FORTRAN_NAME(HIPS_SET_OPTION_INT)(INTS *id, INTS *number, INTS *value);
void FORTRAN_NAME(HIPS_SET_OPTION_REAL)(INTS *id, INTS *number, double *value);
void FORTRAN_NAME(HIPS_GRAPH_SET_GLOBAL_CSR)(INTS *id, INTS *n, INTL *ig, INTS *jg, INTS *dof);
void FORTRAN_NAME(HIPS_GRAPH_BUILD_HID)(INTS *id);
void FORTRAN_NAME(HIPS_SAVE_HIERACH_GRAPH_DECOMP)(INTS *id, char* sfile_path);
void FORTRAN_NAME(HIPS_LOAD_HIERACH_GRAPH_DECOMP)(INTS *id, char* sfile_path);
void FORTRAN_NAME(HIPS_PARALLEL_SETUP)(INTS *id);
void FORTRAN_NAME(HIPS_SET_COMMUNICATOR)(INTS *id, MPI_Fint *commid);
void FORTRAN_NAME(HIPS_SET_MATRIX_COEF)(INTS *id, INTS *job, INTS *over_add, INTS *ln, INTL *lia, INTS *lja, COEF *la, INTS *sym_matrix, INTS *nodelist);
void FORTRAN_NAME(HIPS_SET_MATRIX_COEF_DG)(INTS *id, INTS *job, INTS *over_add, INTS *ln, INTL *lia, INTS *ja, COEF *la, INTS *sym_matrix, INTS *nodelist);
void FORTRAN_NAME(HIPS_MATRIX_RESET)(INTS *id);
void FORTRAN_NAME(HIPS_PRECOND)(INTS *id);
void FORTRAN_NAME(HIPS_MATRIX_VECTOR_PRODUCT)(INTS *id, COEF *x, COEF *y);
void FORTRAN_NAME(HIPS_SET_LOCAL_RHS)(INTS *id, INTS *job, COEF *b);
void FORTRAN_NAME(HIPS_SOLVE)(INTS *id);
void FORTRAN_NAME(HIPS_GET_LOCAL_SOL)(INTS *id, COEF *x);
void FORTRAN_NAME(HIPS_GET_GLOBAL_SOL)(INTS *id, INTS *proc_root, COEF *globx);

void FORTRAN_NAME(HIPS_SET_PARTITION)(INTS *id, INTS *overlap, INTS *ndom, INTS *mapptr, INTS *mapp);
void FORTRAN_NAME(HIPS_CLEAN)(INTS *id);
void FORTRAN_NAME(HIPS_FINALIZE)();
**/
#endif
