/******************************************************************************/
/* Copyright 2008-2009 CNRS, INRIA                                            */
/*                                                                            */
/* File          : io.h                                                       */
/*                                                                            */
/* Description   : This file is part of HIPS : Hierarchical Iterative         */
/*                 Parallel Solver (http://hips.gforge.inria.fr/).            */
/*                                                                            */
/* Authors       : J. GAIDAMOUR and P. HENON                                  */
/******************************************************************************/

/******************************************************************************/
/* License       : CeCILL-C                                                   */
/*                                                                            */
/* This software is governed by the CeCILL-C license under French law and     */
/* abiding by the rules of distribution of free software. You can use,        */
/* modify and/or redistribute the software under the terms of the             */
/* CeCILL-C license as circulated by CEA, CNRS and INRIA at the following     */
/* URL: "http://www.cecill.info".                                             */
/*                                                                            */
/* As a counterpart to the access to the source code and rights to copy,      */
/* modify and redistribute granted by the license, users are provided         */
/* only with a limited warranty and the software's author, the holder of      */
/* the economic rights, and the successive licensors have only limited        */
/* liability.                                                                 */
/*                                                                            */
/* In this respect, the user's attention is drawn to the risks associated     */
/* with loading, using, modifying and/or developing or reproducing the        */
/* software by the user in light of its specific status of free software,     */
/* that may mean that it is complicated to manipulate, and that also          */
/* therefore means that it is reserved for developers and experienced         */
/* professionals having in-depth computer knowledge. Users are therefore      */
/* encouraged to load and test the software's suitability as regards          */
/* their requirements in conditions enabling the security of their            */
/* systems and/or data to be ensured and, more generally, to use and          */
/* operate it in the same conditions as regards security.                     */
/*                                                                            */
/* The fact that you are presently reading this means that you have had       */
/* knowledge of the CeCILL-C license and that you accept its terms.           */
/******************************************************************************/


#ifndef IO_H
#define IO_H

#define DRIVER_AUTO -1
#define DRIVER_USER 1
#define DRIVER_IOHB 2
#define DRIVER_IOMM 3
#define DRIVER_IJV 4
#define DRIVER_IJV3FILES 5
#define DRIVER_SPKIT 6
#define DRIVER_IAJAMA 7

#define DRIVER_DEFAULT DRIVER_AUTO

int CSRread(char* matrix, INTS *t_n, INTL* t_nnz, INTL** t_ia, INTS** t_ja, COEF** t_a, INTS* sym_matrix);
void VECread(char *filename, INTS n, COEF *rhs);

void CSR_Fnum2Cnum(INTS *ja, INTL *ia, INTS n);


/* In hips.h du to fortran interface */
/*void Matrix_Read(INTS job, char* matrix, INTS *t_n, INTL* t_nnz, INTL * ia, INTS * ja, COEF* a, INTS* sym_matrix);*/

#endif


