/******************************************************************************/
/* Copyright 2008-2009 CNRS, INRIA                                            */
/*                                                                            */
/* File          : localdefs.h                                                */
/*                                                                            */
/* Description   : This file is part of HIPS : Hierarchical Iterative         */
/*                 Parallel Solver (http://hips.gforge.inria.fr/).            */
/*                                                                            */
/* Authors       : J. GAIDAMOUR and P. HENON                                  */
/******************************************************************************/

/******************************************************************************/
/* License       : CeCILL-C                                                   */
/*                                                                            */
/* This software is governed by the CeCILL-C license under French law and     */
/* abiding by the rules of distribution of free software. You can use,        */
/* modify and/or redistribute the software under the terms of the             */
/* CeCILL-C license as circulated by CEA, CNRS and INRIA at the following     */
/* URL: "http://www.cecill.info".                                             */
/*                                                                            */
/* As a counterpart to the access to the source code and rights to copy,      */
/* modify and redistribute granted by the license, users are provided         */
/* only with a limited warranty and the software's author, the holder of      */
/* the economic rights, and the successive licensors have only limited        */
/* liability.                                                                 */
/*                                                                            */
/* In this respect, the user's attention is drawn to the risks associated     */
/* with loading, using, modifying and/or developing or reproducing the        */
/* software by the user in light of its specific status of free software,     */
/* that may mean that it is complicated to manipulate, and that also          */
/* therefore means that it is reserved for developers and experienced         */
/* professionals having in-depth computer knowledge. Users are therefore      */
/* encouraged to load and test the software's suitability as regards          */
/* their requirements in conditions enabling the security of their            */
/* systems and/or data to be ensured and, more generally, to use and          */
/* operate it in the same conditions as regards security.                     */
/*                                                                            */
/* The fact that you are presently reading this means that you have had       */
/* knowledge of the CeCILL-C license and that you accept its terms.           */
/******************************************************************************/


#if defined(IBM) || defined(SP2) || defined(RS6000)
#define wreadmtc wreadmtc
#define wreadmtc64 wreadmtc64
#define userread userread  
#define nod2dom nod2dom
#define roscal roscal
#define coscal coscal
#define Fcsrcsc fcsrcsc
#define Faplb   faplb
#define Fcsrcscc fcsrcscc
#define Faplbc   faplbc
#define expnddom expnddom
#define dse3 dse3
#define gen5pt gen5pt
#elif defined(SGI)
#define wreadmtc wreadmtc_
#define wreadmtc64 wreadmtc64_
#define userread userread_  
#define nod2dom nod2dom_
#define roscal roscal_
#define coscal coscal_
#define Fcsrcsc fcsrcsc_
#define Faplb   faplb_
#define Fcsrcscc fcsrcscc_
#define Faplbc   faplbc_
#define expnddom expnddom_
#define dse3 dse3_
#define gen5pt gen5pt_
#elif defined(CRAY)
#define wreadmtc WREADMTC
#define wreadmtc64 WREADMTC64
#define userread USERREAD
#define nod2dom NOD2DOM
#define roscal ROSCAL
#define coscal COSCAL
#define Fcsrcsc FCSRCSC
#define Faplb   FAPLB
#define Fcsrcscc FCSRCSCC
#define Faplbc   FAPLBC
#define expnddom EXPNDDOM
#define dse3 DSE3
#define gen5pt GEN5PT
#else
#define wreadmtc wreadmtc_
#define wreadmtc64 wreadmtc64_
#define userread userread_
#define nod2dom nod2dom_
#define roscal roscal_
#define coscal coscal_
#define Fcsrcsc fcsrcsc_
#define Faplb   faplb_
#define Fcsrcscc fcsrcscc_
#define Faplbc   faplbc_
#define expnddom expnddom_
#define dse3 dse3_
#define gen5pt gen5pt_
#endif

/* for outer and inner functions */
extern void userread(char *fname, int *len, int *job, int *n, INTL
                      *nnz, REAL *a, int *ja, INTL *ia, int *nrhs,
                      REAL *rhs, int *ierr); 
extern void wreadmtc(int *nmax, int *nzmax, int *job, char *fname ,int
                     *len, REAL *a, int *ja, int *ia, REAL *rhs, 
		     int *nrhs, char *guesol, int *nrow, int *ncol,
		     int *nnz, char *title, char *key, char *type, int *ierr);

extern void wreadmtc64(int64_t *nmax, int64_t *nzmax, int64_t *job, int64_t
                     *len, REAL *a, int64_t *ja, int64_t *ia, REAL *rhs, 
		     int64_t *nrhs, char *guesol, int64_t *nrow, int64_t *ncol,
		     int64_t *nnz, char *title, char *key, char *type, int64_t *ierr, char *fname);

extern void nod2dom(int *n, int *ndom, int *nodes, int *pointer, int
		    *map, int *mapsize, int *ier);
extern void roscal(int *n, int *job, int *nrm, REAL *a, int *ja, int
		   *ia, REAL *diag, REAL *b, int *jb, int *ib, int
		   *ierr);
extern void coscal(int *n, int *job, int *nrm, REAL *a, int *ja, int
		   *ia, REAL *diag, REAL *b, int *jb, int *ib, int
		   *ierr);
extern void Fcsrcsc(int *n, int *job, int *ipos, REAL *a, int *ja,
		   int *ia, REAL *ao, int *jao, int *iao);
extern void Faplb(int *nrow, int *ncol, int *job, REAL *a, int *ja,
		 int *ia, REAL *b, int *jb, int *ib, REAL *c, int
		 *jc, int *ic, int *nnzmax, int *iw, int *ierr);
extern void Fcsrcscc(int *n, int *job, int *ipos, COEF *a, int *ja,
		   int *ia, COEF *ao, int *jao, int *iao);
extern void Faplbc(int *nrow, int *ncol, int *job, COEF *a, int *ja,
		 int *ia, COEF *b, int *jb, int *ib, COEF *c, int
		 *jc, int *ic, int *nnzmax, int *iw, int *ierr);
extern  void expnddom(int *, int *,  int *,  int *, int *, int *, int 
		       *, int *, int *, int *);
extern void dse3(int *n,int *ja,int *ia,int *ndom,int *dom,int *domptr,int *mask,int *riord,int *jwk,int *link);
extern void gen5pt(int *nx,int *ny,int *nz, REAL *a,int *ja,int *ia, int *iau);


/*-----------------------------------------------------------------------*/

