/******************************************************************************/
/* Copyright 2008-2009                                                        */
/*                                                                            */
/* File          : phidal_prec.h                                              */
/*                                                                            */
/* Description   : This file is part of HIPS : Hierarchical Iterative         */
/*                 Parallel Solver (http://hips.gforge.inria.fr/).            */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* License       : CeCILL-C                                                   */
/*                                                                            */
/* This software is governed by the CeCILL-C license under French law and     */
/* abiding by the rules of distribution of free software. You can use,        */
/* modify and/or redistribute the software under the terms of the             */
/* CeCILL-C license as circulated by CEA, CNRS and INRIA at the following     */
/* URL: "http://www.cecill.info".                                             */
/*                                                                            */
/* As a counterpart to the access to the source code and rights to copy,      */
/* modify and redistribute granted by the license, users are provided         */
/* only with a limited warranty and the software's author, the holder of      */
/* the economic rights, and the successive licensors have only limited        */
/* liability.                                                                 */
/*                                                                            */
/* In this respect, the user's attention is drawn to the risks associated     */
/* with loading, using, modifying and/or developing or reproducing the        */
/* software by the user in light of its specific status of free software,     */
/* that may mean that it is complicated to manipulate, and that also          */
/* therefore means that it is reserved for developers and experienced         */
/* professionals having in-depth computer knowledge. Users are therefore      */
/* encouraged to load and test the software's suitability as regards          */
/* their requirements in conditions enabling the security of their            */
/* systems and/or data to be ensured and, more generally, to use and          */
/* operate it in the same conditions as regards security.                     */
/*                                                                            */
/* The fact that you are presently reading this means that you have had       */
/* knowledge of the CeCILL-C license and that you accept its terms.           */
/******************************************************************************/

#include "prec.h"
#include "matrix.h"

struct PhidalPrec_ {
  flag_t symmetric; 
  dim_t dim; /** The dimension of the  system  to be preconditioned **/
  int_t levelnum;
  int_t forwardlev;
  
  Matrix* LU;
/*   PhidalMatrix *L; */
/*   PhidalMatrix *U; */

#if defined(ILUT_WHOLE_SCHUR) || defined(ILUT_SOLVE)
#error sss
  csptr csL;
  csptr csU;
#endif

  COEF *D;
  Matrix *EF;
/*   PhidalMatrix *E; */
/*   PhidalMatrix *F; */
/*   PhidalMatrix *S; */
/*   PhidalMatrix *B; */
  Matrix *S;
  Matrix *B;

  /*PhidalMatrix *C;  OPTIMREC forward */
  PhidalPrec *prevprec;
  PhidalPrec *nextprec;
  flag_t schur_method;  /** Indicate the smoothing method in the multi-level;
			  0 := no smoothing; in this case the schur complement S is not stored
			  1 := iteration in the schur complement with storage of the schur complement
			  2 := iteration in the schur complement with implicit schur complement (schur not stored) */

  flag_t pivoting;  /** 1 := column pivoting in ILUTP */
  dim_t *permtab;

  /* REAL tol_schur; */
  
  PrecInfo* info;
};
